     H CopyRight('Copyright Someone (c) - 2015')
     H DatEdit(*YMD.)
     H Option( *SrcStmt: *NoDebugIO)
     H DECEDIT('0.')

     H BndDir('QC2LE')

      /If Defined(*Crtbndrpg)
     H BndDir( '*LIBL/CGIBNDDIR' )
     H DftActGrp(*NO)
      /Endif

      //*=============================================================
      //*
      //* Function  :Generate random number and pass back to browser
      //*
      //* ------------------------------------------------------------
      //* Created:
      //* Programmer:JJ
      //* Date  . . :2015-07-06
      //*
      //*=============================================================

      //==============================================================
      //            DECLARE WORK FIELDS, ARRAYS AND MORE
      //==============================================================

      // Contants
     D XMLHeader       c                   Const('Content-type: text/xml')
     D NewLine         c                   Const(X'15')

     D WrkLine         s           2000a   varying

     D Str             s              2a
     D min             s              3u 0 Inz( x'F0' )
     D max             s              3u 0 Inz( x'F9' )
     D idx             s              5u 0
     D seed            s             10i 0
     D random          s              8f

     D char            Ds
     D  hex                           3u 0

      //----------------------------------------------------------------
      // Prototypes
      //----------------------------------------------------------------
     D MakeXML         pr
     D   StringIn                  2000    value

     d getrandom       pr                  ExtProc( 'CEERAN0' )
     d  seed                         10i 0
     d  rand                          8f
     D  fc                             *   Options( *Omit )

      /free

       //---------------------------------------------------------------
       //Generate number
       //---------------------------------------------------------------

          For       Idx = 1 to %Len( Str );
             CallP     getrandom( seed: random: *Omit );
             Eval      hex = ( random * ( max - min )) + min;
             Eval      %Subst( str: idx: 1 ) = char;
          EndFor;

          // Number found
          Str = Str;

       //---------------------------------------------------------------
       // Tell browser XML is coming
       //---------------------------------------------------------------
       // Content-Type
          MakeXML ( %trim(XMLHeader)  + NewLine + NewLine );

       //---------------------------------------------------------------
       // Create output
       //---------------------------------------------------------------
         ExSr subrCreateReply;

       //---------------------------------------------------------------
       // Stop Program
       //---------------------------------------------------------------
         ExSr StopPgm;

       //---------------------------------------------------------------
       // Create XML reply
       //---------------------------------------------------------------
       BegSr subrCreateReply;

          WrkLine   = '<?xml version="1.0" encoding="UTF-8"?>'
                    +  '<data>'
                    ;
          MakeXML ( %trim(WrkLine) + NewLine );

                 WrkLine = '<update_date>'
                         + %char( %date() )
                         + '</update_date>'

                         + '<update_time>'
                         + %char( %time() )
                         + '</update_time>'

                         + '<pct>'
                         + %trim( Str )
                         + '</pct>'

                         ;

                 // Write to browser
                 WrkLine   = %trim( WrkLine );
                 MakeXML ( %trim(WrkLine) + NewLine );

                 // Write to browser
                 WrkLine   = '</data>'
                           ;
                 MakeXML ( %trim(WrkLine) + NewLine );

       EndSr;

       //---------------------------------------------------------------
       // Stop Program
       //---------------------------------------------------------------
       BegSr StopPgm;

         *inLR = *ON;
         Return;

       EndSr;

       //---------------------------------------------------------------
       // Global error catcher
       //---------------------------------------------------------------
       BegSr *PSSR;

       EndSr;

      /end-free

       //================================================================
       // Function MakeXML  - Write string to StdOut
       //================================================================
     P MakeXML         b

     D MakeXML         pi
     D  StringIn                   2000    value

     D Work            s                   like(StringIn)
     D StdOutLen       s              9B 0

      //----------------------------------------------------------------
      // General API error routine
      //----------------------------------------------------------------
     DQUSEC            DS
     D qusbprv                 1      4B 0 Inz( 16 )                            Qus EC
     D qusbavl                 5      8B 0                                      Bytes Provided
     D qusei                   9     15                                         Bytes Available
     D quserved               16     16                                         Exception Id

      //----------------------------------------------------------------
      // Calculate length of StdOut string
      //----------------------------------------------------------------

      /free

            Work      = %trim(StringIn);

            Work = %trim(Work);

            StdOutLen = %CheckR(' ':Work);

      /end-free

      //----------------------------------------------------------------
      // Call QtmhWrStout API to write response HTML to StdOut
      //----------------------------------------------------------------

     C                   CallB(e)  'QtmhWrStout'
     C                   Parm                    Work
     C                   Parm                    StdOutLen
     C                   Parm                    QUSEC

     P MakeXML         e
